import { EntityBreathableComponent, EntityMovementComponent, MinecraftBlockTypes, MinecraftEffectTypes, Vector, system, world } from "@minecraft/server";
import { ActionFormData, ModalFormData, } from '@minecraft/server-ui';

function getScore(target, objective) {
    try {
        return world.scoreboard.getObjective(objective).getScore(typeof target === 'string' ? oB.getParticipants().find(pT => pT.displayName == target) : target.scoreboardIdentity)
    } catch {
        return 0
    }
}
//para conprobar el script
system.runInterval(() => {
    //world.getDimension("overworld").runCommandAsync('')
})

world.beforeEvents.chatSend.subscribe((ev) => {
    const player = ev.sender
    const msg = ev.message
    const prefix = "."

    if (msg.startsWith(prefix)) {
        ev.cancel = true
    }
    // Verificar si el mensaje comienza con el prefijo y contiene "chatedit" (sin importar mayúsculas o minúsculas)
    if (msg.toLowerCase().startsWith(prefix.toLowerCase()) && msg.toLowerCase().includes("chatedit")) {
        ev.cancel = true
        if (player.hasTag('admin')) {
            player.runCommandAsync(`tag @s add chateditmenu`)
            player.sendMessage({ translate: "command.succes.chat.close.move" })
        } else {
            player.sendMessage({ translate: "command.admin.fail" })
        }
    } if (msg.toLowerCase().startsWith(prefix.toLowerCase()) && msg.toLowerCase().includes("adminchat")) {
        ev.cancel = true
        if (player.hasTag('admin')) {
            if (player.hasTag('adminchat')) {
                player.runCommandAsync(`tag @s remove adminchat`)
                player.sendMessage({ translate: "command.admin.chat.off" })
            } else {
                player.runCommandAsync(`tag @s add adminchat`)
                player.sendMessage({ translate: "command.admin.chat.on" })
            }
        } else {
            player.sendMessage({ translate: "command.admin.fail" })
        }
    }
});

const Color_Pordefecto = "§b";
const Rango_Pordefecto = "";
const Separador_Pordefecto = "§l§7>>§r";
const SeparadorInicial_Pordefecto = "§l§7[§r";
const SeparadorFinal_Pordefecto = "§l§7]§r";
const SeparadorEntreRangos_Pordefecto = "§l§7/§r";
const TagM_Pordefecto = "§f";

function calculateSpeed(Vx, Vy, Vz) {
    return Math.sqrt(Vx ** 2 + Vy ** 2 + Vz ** 2);
}

system.runInterval(() => {
    for (let player of world.getPlayers()) {
        const tags = player.getTags();
        const filteredTagsrank = ((filteredTagsrank) => { if (filteredTagsrank.length === 0) { return 'default'; } else { return 'eliminar ' + filteredTagsrank.join(', ') } })(tags.filter(tag => tag.startsWith('r:')).map(tag => tag.substring(2)))
        //console.warn('xd:' + filteredTagsrank)
        let speed = calculateSpeed(player.getVelocity().x, player.getVelocity().y, player.getVelocity().z);
        if (player.hasTag("chateditmenu") && speed > 0.001) {
            chatrankadminnmenu(player);

            player.runCommandAsync(`tag @s remove chateditmenu`)
        }
    }
}
)





function chatrankadminnmenu(player) {
    system.run(() => {
        const form = new ActionFormData()
        form.title({ translate: "menu.config.title" })

        const players = Array.from(world.getPlayers()) // Obtener lista de jugadores
        for (const targetPlayer of players) {
            const playerName = targetPlayer.name
            const playerTag = targetPlayer.hasTag("admin") ? "admin" : "member"

            // Agregar botón por cada jugador con su nombre y rango
            form.button('§l§1' + playerName + '\n§l§9' + playerTag)
        }

        form.show(player).then(result => {
            const selectedPlayer = players[result.selection]
            if (result.selection === undefined) {
            } else {
                chatrankplayereditadminmenu(player, selectedPlayer)
            }
        })
    }
    )
}


function chatrankplayereditadminmenu(player, selectedPlayer) {
    system.run(() => {
        const form = new ActionFormData()
        form.title({ translate: "menu.config.title" })
        form.body({ translate: "menu.explanation.selected.player" })
        form.button({ translate: "menu.add.selected.player" }, 'font/ui/green+')
        form.button({ translate: "menu.remove.selected.player" }, 'font/ui/red-')
        form.button({ translate: "menu.config.selected.player" }, 'font/ui/config')
        form.show(player).then(result => {
            if (result.selection === 0) {
                chatrankplayereditadminmenuañadir(player, selectedPlayer)
            }
            if (result.selection === 1) {
                chatrankplayereditadminmenueliminar(player, selectedPlayer)
            }
            if (result.selection === 2) {
                chatrankconfig(player, selectedPlayer);
            }
            if (result.selection === undefined) {
                chatrankadminnmenu(player)
            }
        })
    })
}


function chatrankplayereditadminmenuañadir(player, selectedPlayer) {
    system.run(() => {
        const form = new ModalFormData()
        //  const selectedPlayerRanks = String(selectedPlayer.getTags().find(tag => tag.startsWith("r:"))?.split("r:")[1] || Rango_Pordefecto_test)
        form.title(`§l§1§k!!§r §l§1${selectedPlayer.name} §k!!§r`);
        form.textField(`§l§9The text in §eayellow§9 is what will change\n§l§9Add leading parentheses\n§l§e[§r §7Rank1 §l§7/§r §7Rank2 §l§7]§r §7${selectedPlayer.name} §l§7>>§r §f`, `[`)
        form.textField(`§l§9Add rank\n§l§7[§r §eRank1 §l§7/§r §eRank2 §l§7]§r §7${selectedPlayer.name} §l§7>>§r §f`, `Rank`)
        form.textField(`§l§9Add rank separator\n§l§7[§r §7Rank1 §l§e/§r §7Rank2 §l§7]§r §7${selectedPlayer.name} §l§7>>§r §f`, `/`)
        form.textField(`§l§9Add trailing parentheses\n§l§7[§r §7Rank1 §l§7/§r §7Rank2 §l§e]§r §7${selectedPlayer.name} §l§7>>§r §f`, `]`)
        form.textField(`§l§9Add color to name\n§l§7[§r §7Rank1 §l§7/§r §7Rank2 §l§7]§r §e${selectedPlayer.name} §l§7>>§r §f`, `color`)
        form.textField(`§l§9Add name separator\n§l§7[§r §7Rank1 §l§7/§r §7Rank2 §l§7]§r §7${selectedPlayer.name} §l§e>>§r §f`, `>>`)
        form.textField(`§l§9Add color to message\n§l§7[§r §7Rank1 §l§7/§r §7Rank2 §l§7]§r\n§7${selectedPlayer.name} §l§7>>§r §emensaje`, `color`)
        //form.toggle('§l§9Enviar groserias al chat', player.hasTag('chatrankcaninsult'))
        form.show(player).then(result => {
            if (result.selection === undefined) {
                chatrankplayereditadminmenu(player, selectedPlayer)
            }
            if (result.formValues[0].length > 0) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" add "i:${result.formValues[0]}"`)
            }
            if (result.formValues[1].length > 0) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" add "r:${result.formValues[1]}"`);
            }

            if (result.formValues[2].length > 0) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" add "d:${result.formValues[2]}"`);
            }

            if (result.formValues[3].length > 0) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" add "f:${result.formValues[3]}"`);
            }

            if (result.formValues[4].length > 0) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" add "c:${result.formValues[4]}"`);
            }

            if (result.formValues[5].length > 0) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" add "s:${result.formValues[5]}"`);
            }

            if (result.formValues[6].length > 0) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" add "m:${result.formValues[6]}"`);
            }
        })
    })
}




function chatrankplayereditadminmenueliminar(player, selectedPlayer) {
    system.run(() => {
        const form = new ModalFormData();
        const tags = selectedPlayer.getTags();
        const tagseparadorinicial = tags.filter(tag => tag.startsWith('i:')).map(tag => tag.substring(2));
        const tagrank = tags.filter(tag => tag.startsWith('r:')).map(tag => tag.substring(2));
        const tagseparadorentrerangos = tags.filter(tag => tag.startsWith('d:')).map(tag => tag.substring(2));
        const tagseparadorfinal = tags.filter(tag => tag.startsWith('f:')).map(tag => tag.substring(2));
        const tagcolordelnombre = tags.filter(tag => tag.startsWith('c:')).map(tag => tag.substring(2) + 'color');
        const tagseparadornombrechat = tags.filter(tag => tag.startsWith('s:')).map(tag => tag.substring(2));
        const tagcolorchatchat = tags.filter(tag => tag.startsWith('m:')).map(tag => tag.substring(2) + 'color');

        const sleeciconarparaeliminar = { translate: "menu.remove.sleeciconarparaeliminar" }

        const separadorinicialresult = ((tagseparadorinicial) => {
            if (tagseparadorinicial.length === 0) {
                return ['Default']; // Opción predeterminada si no hay rangos
            } else {
                return [sleeciconarparaeliminar, ...tagseparadorinicial]; // Agregar "eliminar rango" y los rangos
            }
        })(tagseparadorinicial);

        const rankresult = ((tagrank) => {
            if (tagrank.length === 0) {
                return ['Default']; // Opción predeterminada si no hay rangos
            } else {
                return [sleeciconarparaeliminar, ...tagrank]; // Agregar "eliminar rango" y los rangos
            }
        })(tagrank);

        const separadorderangosresult = ((tagseparadorentrerangos) => {
            if (tagseparadorentrerangos.length === 0) {
                return ['Default']; // Opción predeterminada si no hay rangos
            } else {
                return [sleeciconarparaeliminar, ...tagseparadorentrerangos]; // Agregar "eliminar rango" y los rangos
            }
        })(tagseparadorentrerangos);

        const separadorfinalresult = ((tagseparadorfinal) => {
            if (tagseparadorfinal.length === 0) {
                return ['Default']; // Opción predeterminada si no hay rangos
            } else {
                return [sleeciconarparaeliminar, ...tagseparadorfinal]; // Agregar "eliminar rango" y los rangos
            }
        })(tagseparadorfinal);

        const colordelnombreresult = ((tagcolordelnombre) => {
            if (tagcolordelnombre.length === 0) {
                return ['Default']; // Opción predeterminada si no hay rangos
            } else {
                return [sleeciconarparaeliminar, ...tagcolordelnombre]; // Agregar "eliminar rango" y los rangos
            }
        })(tagcolordelnombre);

        const separadornombrechatresult = ((tagseparadornombrechat) => {
            if (tagseparadornombrechat.length === 0) {
                return ['Default']; // Opción predeterminada si no hay rangos
            } else {
                return [sleeciconarparaeliminar, ...tagseparadornombrechat]; // Agregar "eliminar rango" y los rangos
            }
        })(tagseparadornombrechat);

        const colorchatresult = ((tagcolorchatchat) => {
            if (tagcolorchatchat.length === 0) {
                return ['Default']; // Opción predeterminada si no hay rangos
            } else {
                return [sleeciconarparaeliminar, ...tagcolorchatchat]; // Agregar "eliminar rango" y los rangos
            }
        })(tagcolorchatchat);




        form.title(`§l§1§k!!§r §l§1${selectedPlayer.name} §k!!§r`);
        form.dropdown(`§l§9The text in §eayellow§9 is what will change\n§l§9Delete leading parentheses\n§l§e[§r §7Rank1 §l§7/§r §7Rank2 §l§7]§r §7${selectedPlayer.name} §l§7>>§r §f`, separadorinicialresult)
        form.dropdown(`§l§9Delete rank\n§l§7[§r §eRank1 §l§7/§r §eRank2 §l§7]§r §7${selectedPlayer.name} §l§7>>§r §f`, rankresult);
        form.dropdown(`§l§9Delete rank separator\n§l§7[§r §7Rank1 §l§e/§r §7Rank2 §l§7]§r §7${selectedPlayer.name} §l§7>>§r §f`, separadorderangosresult)
        form.dropdown(`§l§9Delete trailing parentheses\n§l§7[§r §7Rank1 §l§7/§r §7Rank2 §l§e]§r §7${selectedPlayer.name} §l§7>>§r §f`, separadorfinalresult)
        form.dropdown(`§l§9Delete color to name\n§l§7[§r §7Rank1 §l§7/§r §7Rank2 §l§7]§r §e${selectedPlayer.name} §l§7>>§r §f`, colordelnombreresult)
        form.dropdown(`§l§9Delete name separator\n§l§7[§r §7Rank1 §l§7/§r §7Rank2 §l§7]§r §7${selectedPlayer.name} §l§e>>§r §f`, separadornombrechatresult)
        form.dropdown(`§l§9Delete color to message\n§l§7[§r §7Rank1 §l§7/§r §7Rank2 §l§7]§r\n§7${selectedPlayer.name} §l§7>>§r §emensaje`, colorchatresult)

        form.show(player).then(result => {
            if (result.selection === undefined) {
                chatrankplayereditadminmenu(player, selectedPlayer)
            }
            const result0 = separadorinicialresult[result.formValues[0]]
            const result1 = rankresult[result.formValues[1]]
            const result2 = separadorderangosresult[result.formValues[2]]
            const result3 = separadorfinalresult[result.formValues[3]]
            const result4 = colordelnombreresult[result.formValues[4]]
            const result5 = separadornombrechatresult[result.formValues[5]]
            const result6 = colorchatresult[result.formValues[6]]

            if (result0.length > 0) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" remove "i:${result0}"`)
            }
            if (result1.length > 0) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" remove "r:${result1}"`);
            }

            if (result2.length > 0) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" remove "d:${result2}"`);
            }

            if (result3.length > 0) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" remove "f:${result3}"`);
            }

            if (result4.length > 0) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" remove "c:${result4.replace(/color/g, "")}"`);
            }

            if (result5.length > 0) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" remove "s:${result5}"`);
            }

            if (result6.length > 0) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" remove "m:${result6.replace(/color/g, "")}"`);
            }
        });
    })
}


function chatrankconfig(player, selectedPlayer) {
    system.run(() => {
        const form = new ModalFormData();
        form.title(`§l§1§k!!§r §l§1${selectedPlayer.name} §k!!§r`);
        form.toggle({ translate: "menu.config.can.insult" }, selectedPlayer.hasTag('chatrankcaninsult'))
        form.toggle({ translate: "menu.config.can.speak" }, !selectedPlayer.hasTag('chatrankmute'))
        form.toggle({ translate: "menu.config.can.see.msg" }, !selectedPlayer.hasTag('chatranknotsee'))
        form.show(player).then(result => {
            if (result.selection === undefined) {
                chatrankplayereditadminmenu(player, selectedPlayer)
            }
            if (result.formValues[0] === true) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" add "chatrankcaninsult"`);
            } else {
                player.runCommandAsync(`tag "${selectedPlayer.name}" remove "chatrankcaninsult"`);
            }
            if (result.formValues[1] === true) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" remove "chatrankmute"`);
            } else {
                player.runCommandAsync(`tag "${selectedPlayer.name}" add "chatrankmute"`);
            }
            if (result.formValues[2] === true) {
                player.runCommandAsync(`tag "${selectedPlayer.name}" remove "chatranknotsee"`);
            } else {
                player.runCommandAsync(`tag "${selectedPlayer.name}" add "chatranknotsee"`);
            }
        })

    })
}

const watermark = String.fromCharCode(167, 52, 91, 167, 101, 83, 97, 116, 97, 110, 105, 99, 32, 67, 104, 97, 116, 32, 82, 97, 110, 107, 167, 52, 93);




world.beforeEvents.chatSend.subscribe(data => {
    data.cancel = true
    const getTagValue = (tag, defaultValue = "") => {
        return data.sender.getTags().find(t => t.startsWith(tag))?.substring(tag.length) || defaultValue;
    };
    const player = data.sender
    const msg = data.message
    const prefix = "."

    const Color = getTagValue("c:", Color_Pordefecto);
    const Rangos = data.sender.getTags().filter(t => t.startsWith("r:")).map(t => t.substring(2));
    const Separador = getTagValue("s:", Separador_Pordefecto);
    const SeparadorInicial = getTagValue("i:", SeparadorInicial_Pordefecto);
    const SeparadorFinal = getTagValue("f:", SeparadorFinal_Pordefecto);
    const SeparadorEntreRangos = getTagValue("d:", SeparadorEntreRangos_Pordefecto);
    const TagM = getTagValue("m:", TagM_Pordefecto);

    const rangoFormateado = Rangos.length > 0 ? `${SeparadorInicial}§r${Rangos.join(` §r${SeparadorEntreRangos} `)}§r${SeparadorFinal} ` : Rango_Pordefecto;
    function quitarcensura(texto) {
        var vocales = ['E', 'e', 'A', 'a', 'O', 'o', 'U', 'u', 'I', 'i', 'S'];
        var reemplazos = ['╨', '╤', '╥', '╙', '╘', '╒', '╓', '╫', '╪', '┘', '┌'];

        for (var i = 0; i < vocales.length; i++) {
            var expresionRegular = new RegExp(vocales[i], 'g');
            texto = texto.replace(expresionRegular, reemplazos[i]);
        }

        return texto;
    }

    if (data.sender.hasTag('chatrankcaninsult') && !msg.startsWith(prefix) && !data.sender.hasTag('chatrankmute') && !(1 < getScore(data.sender , "chatrankantispamchat"))) {
        const formato = `§r${rangoFormateado}§r${Color}${data.sender.name}§r ${Separador}§r ${TagM}${quitarcensura(data.message)}`;
        world.getDimension("overworld").runCommandAsync(`execute as "${data.sender.name}" as @s[tag=!chatrankmute] as @s[tag=!adminchat] run tellraw @a[tag=!chatranknotsee] {"rawtext":[{"text":"${formato}"}]}`);
        world.getDimension("overworld").runCommandAsync(`execute as "${data.sender.name}" as @s[tag=!chatrankmute] as @s[tag=adminchat] run tellraw @a[tag=admin] {"rawtext":[{"text":"§gAdmin Chat§l§7 >>§r ${formato}"}]}`);
        if (data.sender.hasTag('chatranknotsee')) {
            data.sender.sendMessage(formato)
        }
    } else if (!msg.startsWith(prefix) && !data.sender.hasTag('chatrankmute') && !(1 < getScore(data.sender , "chatrankantispamchat"))) {
        const formato = `§r${rangoFormateado}§r${Color}${data.sender.name}§r ${Separador}§r ${TagM}${data.message}`;
        world.getDimension("overworld").runCommandAsync(`execute as "${data.sender.name}" as @s[tag=!chatrankmute] as @s[tag=!adminchat] run tellraw @a[tag=!chatranknotsee] {"rawtext":[{"text":"${formato}"}]}`);
        world.getDimension("overworld").runCommandAsync(`execute as "${data.sender.name}" as @s[tag=!chatrankmute] as @s[tag=adminchat] run tellraw @a[tag=admin] {"rawtext":[{"text":"§gAdmin Chat§l§7 >>§r ${formato}"}]}`);
        if (data.sender.hasTag('chatranknotsee')) {
            data.sender.sendMessage(formato)
        }
    }
    if (data.sender.hasTag('chatrankmute') && !msg.startsWith(prefix) && !(1 < getScore(data.sender , "chatrankantispamchat"))) {
        data.sender.sendMessage({ translate: "chat.aelrt.mute" })
    }
    if ((1 > getScore(data.sender , "chatrankantispamchat")) && !data.sender.hasTag('chatrankmute')) {
        data.sender.runCommandAsync('scoreboard players set @s chatrankantispamchat 40')
    }
    if ((1 < getScore(data.sender , "chatrankantispamchat"))) {
        var seconds = "WTF? "
        if (20 < getScore(data.sender , "chatrankantispamchat") && 41 > getScore(data.sender , "chatrankantispamchat")) {
            seconds = "2 "
        }
        if (0 < getScore(data.sender , "chatrankantispamchat") && 21 > getScore(data.sender , "chatrankantispamchat")) {
            seconds = "1 "
        }
        if (0 > getScore(data.sender , "chatrankantispamchat")) {
            seconds = "0 "
        }
        data.sender.sendMessage({ translate: "chat.aelrt.spam" , with: [watermark , seconds]})
    }
});

system.runInterval(() => {
    world.getDimension("overworld").runCommandAsync('scoreboard objectives add chatrankantispamchat dummy')
    world.getDimension("overworld").runCommandAsync('scoreboard players remove @a[scores={chatrankantispamchat=1..}] chatrankantispamchat 1')
})